<?php

/*
 * @package Joomla 1.7
 * @copyright Copyright (C) 2013 hypermodern.org. All rights reserved.
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.txt
 *
 * @plugin PreziHM
 * @copyright Copyright (C) Lander Compton www.hypermodern.org
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 */
 
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die;

jimport('joomla.plugin.plugin');

class plgContentprezihm extends JPlugin {
	
	
	public function onContentPrepare($context, &$article, &$params, $limitstart) { 
				
		// get the paramters article and context				
		$this->prezihm_content( $article, $params, $context);
		$document = &JFactory::getDocument();
	
	} // end function
	
	
	public function hmoverrides($overridesraw) {
		
		// Declare the variables global in case an override is needed.
		global $hmwidth, $hmheight, $hmlock, $hmbg, $hmautoplay, $hmautohide, $hmframeborder; 
		
		// Find the [prezihm] tag parameters then put them into array $overrides/
		$regex2 = '/\S*\s?=\s?\"\S*\"/i';
		preg_match_all ( $regex2, $overridesraw, $overrides );
		
		
		unset($keyvalues);
		$keyvalues = array();
		
		// Process the override parameters and put thier values in their respective variables.
		for($x=0; $x<count($overrides[0]); $x++) {
			
			// If there are any spaces or quotes, remove them.
			$overrides[0][$x] = str_replace(' ', '',$overrides[0][$x]);
			$overrides[0][$x] = str_replace("\"", '',$overrides[0][$x]);
			$split = '/=/';
		
			// Split the parameters by =, and place them into key/value pairs.	
			$keyvalue = preg_split($split, $overrides[0][$x]);
			array_push($keyvalues, $keyvalue);
			
		
			if ($keyvalue[0] == 'height') 			{ $hmheight = $keyvalue[1];}
			if ($keyvalue[0] == 'width') 			{ $hmwidth = $keyvalue[1];}
			if ($keyvalue[0] == 'path') 			{ $hmlock = $keyvalue[1];}
			if ($keyvalue[0] == 'bg') 				{ $hmbg = $keyvalue[1];}
			if ($keyvalue[0] == 'autoplay') 		{ $hmautoplay = $keyvalue[1];}
			if ($keyvalue[0] == 'autohide') 		{ $hmautohide = $keyvalue[1];}
			if ($keyvalue[0] == 'fb') 				{ $hmframeborder = $keyvalue[1];}

	
			
			
		} // end for loop
		
	return;
		
	} // end function
	
	
	public function prezihm_content( &$article, &$params, $context = 'com_content.article') {
		
		//devlare globals so the other functions can override
		global $hmwidth, $hmheight, $hmlock, $hmbg, $hmautoplay, $hmautohide, $hmframeborder; 
		
		// example match: [prezihm]------------[/prezihm]
		// $regex =	'/(\[prezihm(.*)\](http:\/\/www.youtube.com\/watch\?v=)([\S]{11})\[\/prezihm\])/i';
		// $regex =	'/(\[prezihm(.*)\]((http|https|rtmp):\/\/.*)\[\/prezihm\])/i';
		$regex = '/(\[prezihm(.*)\]http:\/\/prezi.com\/(............)\/.*\[\/prezihm\])/i';
		// Search out all tags and put them into array $matcheshm.
		preg_match_all( $regex, $article->text, $matcheshm );
	
		
		//process the matches
		for($x=0; $x<count($matcheshm[0]); $x++) {
				
			$hmwidth = $this->params->get( 'hmwidth',425);
			$hmheight = $this->params->get( 'hmheight',375);
			$hmlock = $this->params->get( 'hmpathlock',0);
			$hmbg = $this->params->get( 'hmbgcolor',000000);
			$hmautoplay = $this->params->get( 'hmautoplay',0);
			$hmautohide = $this->params->get( 'hmautohide',0);
			$hmframeborder = $this->params->get( 'hmframeborder',0);
	
			
			
			// If the prezihm tag has args to override, then go to function hmoverrides for processing
			if ($matcheshm[2][$x] != '') {
					$overrides=$this->hmoverrides($matcheshm[2][$x]);
				
			}
			
			
			// http://prezi.com/_cy2pp_dsvj2/heroin-prevalence-factors/?kw=view-_cy2pp_dsvj2&rc=ref-37771643
			// <iframe src="http://prezi.com/embed/_cy2pp_dsvj2/?bgcolor=ffffff&amp;lock_to_path=0&amp;autoplay=0&amp;autohide_ctrls=0&amp;
			// features=undefined&amp;disabled_features=undefined" width="550" height="400" frameBorder="0"></iframe>
		
			// $replace = '<iframe src="' . 'http://prezi.com/embed/_cy2pp_dsvj2/?bgcolor=ffffff&amp;lock_to_path=0&amp;autoplay=0&amp;autohide_ctrls=0&amp;features=undefined&amp;disabled_features=undefined"' .  'width="550" height="400" frameBorder="0"></iframe>';
			$replace = '<iframe src="http://prezi.com/embed/' . $matcheshm[3][$x] . '/?'
				. 	'bgcolor='			.	$hmbg			.	'&amp;'		// hex no #
				.	'lock_to_path=' 	. 	$hmlock 		. 	'&amp;'		// 0 or 1
				.	'autoplay=' 		.	$hmautoplay		.	'&amp;'		// 0 or 1
				.	'autohide_ctrls='	.	$hmautohide		.	'&amp;'
				.	'features=undefined&amp;disabled_features=undefined"'
				. 	'width="' 			. 	$hmwidth		. 	'"'
				. 	'height="' 			. 	$hmheight		.	'"' 
				. 	'frameBorder="'		.	$hmframeborder	.	'"></iframe>';
				
		

				// Execute and replace the [prezihm] tags and their contents.
				$article->text = str_replace($matcheshm[1][$x], $replace, $article->text);
				
				
		} // end for loop
	} // end function hmtubetube_content
	
	
} // end class
?>